## unarr 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

project(unarr VERSION 1.0.0 LANGUAGES C)
set(PROJECT_DESCRIPTION
  "A decompression library for rar, tar and zip files.")

include(GNUInstallDirs)

# Set build type to default if unset.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# Build options
option(BUILD_SHARED_LIBS "Build ${PROJECT_NAME} as a shared library" ON)

# Build target
add_library(unarr
  _7z/_7z.h
  _7z/_7z.c
  common/allocator.h
  common/unarr-imp.h
  common/conv.c
  common/crc32.c
  #common/custalloc.c
  common/stream.c
  common/unarr.c
  lzmasdk/7zTypes.h
  lzmasdk/CpuArch.h
  lzmasdk/Ppmd.h
  lzmasdk/Ppmd7.h
  lzmasdk/Ppmd8.h
  lzmasdk/Precomp.h
  lzmasdk/CpuArch.c
  lzmasdk/Ppmd7.c
  lzmasdk/Ppmd8.c
  lzmasdk/Ppmd7Dec.c
  lzmasdk/Ppmd8Dec.c
  rar/lzss.h
  rar/rar.h
  rar/rarvm.h
  rar/filter-rar.c
  rar/uncompress-rar.c
  rar/huffman-rar.c
  rar/rar.c
  rar/rarvm.c
  rar/parse-rar.c
  tar/tar.h
  tar/parse-tar.c
  tar/tar.c
  zip/inflate.h
  zip/zip.h
  zip/inflate.c
  zip/parse-zip.c
  zip/uncompress-zip.c
  zip/zip.c)

set_target_properties(unarr PROPERTIES
                      PUBLIC_HEADER unarr.h
                      C_VISIBILITY_PRESET hidden
                      C_STANDARD 99
                      C_STANDARD_REQUIRED ON
                      DEFINE_SYMBOL UNARR_EXPORT_SYMBOLS
                      VERSION ${PROJECT_VERSION}
                      SOVERSION ${PROJECT_VERSION_MAJOR})

if(BUILD_SHARED_LIBS)
  target_compile_definitions(unarr PUBLIC UNARR_IS_SHARED_LIBRARY)
endif()

find_package(BZip2)
if(BZIP2_FOUND)
  target_include_directories(unarr PRIVATE ${BZIP_INCLUDE_DIRS})
  target_link_libraries(unarr ${BZIP2_LIBRARIES})
  target_compile_definitions(unarr PRIVATE -DHAVE_BZIP2)
  # Bzip2 upstream does not supply a .pc file. Add it to Libs.private.
  set(PROJECT_LIBS_PRIVATE "-I${BZIP_INCLUDE_DIRS} -l${BZIP2_LIBRARIES}")
endif()

find_package(LibLZMA)
if(LIBLZMA_FOUND)
  target_include_directories(unarr PRIVATE ${LIBLZMA_INCLUDE_DIRS})
  target_link_libraries(unarr ${LIBLZMA_LIBRARIES})
  target_compile_definitions(unarr PRIVATE -DHAVE_LIBLZMA)
  set(PROJECT_REQUIRES_PRIVATE "${UNARR_REQUIRES_PRIVATE} liblzma")
else()
  target_sources(unarr PRIVATE
    lzmasdk/LzmaDec.h
    lzmasdk/LzmaDec.c)
endif()

find_package(ZLIB)
if(ZLIB_FOUND)
  target_include_directories(unarr PRIVATE ${ZLIB_INCLUDE_DIRS})
  target_link_libraries(unarr ${ZLIB_LIBRARIES})
  target_compile_definitions(unarr PRIVATE -DHAVE_ZLIB)
  # Add zlib to libunarr.pc Requires.private
  set(PROJECT_REQUIRES_PRIVATE "${PROJECT_REQUIRES_PRIVATE} zlib")
endif()

# Compiler specific settings

if(UNIX OR MINGW OR MSYS)
  target_compile_options(unarr PRIVATE -Wall -Wextra -pedantic
                    -Wstrict-prototypes -Wmissing-prototypes
                    -Werror-implicit-function-declaration
                    $<$<CONFIG:Release>:-fomit-frame-pointer>
                    $<$<OR:$<C_COMPILER_ID:Clang>,$<C_COMPILER_ID:AppleClang>>:
                    -Wno-missing-field-initializers>
                    -flto)
  target_compile_definitions(unarr PRIVATE -D_FILE_OFFSET_BITS=64)

  # Linker flags

  # Clang linker needs -flto too when doing lto
  if("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
    set_target_properties(unarr PROPERTIES LINK_FLAGS
                          "-Wl,--no-undefined -Wl,--as-needed -flto")
  # Apple ld uses different syntax for undefined symbol check
  elseif("${CMAKE_C_COMPILER_ID}" STREQUAL "AppleClang")
    set_target_properties(unarr PROPERTIES LINK_FLAGS
                          "-Wl,-undefined,error -flto")
  else()
    set_target_properties(unarr PROPERTIES LINK_FLAGS
                          "-Wl,--no-undefined -Wl,--as-needed")
  endif()
endif()

if(MSVC)
  target_compile_options(unarr PRIVATE /W3
                        $<$<CONFIG:Release>:/Ox>)
  target_compile_definitions(unarr PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

# Write pkg-config file
configure_file("pkg-config.pc.cmake" "lib${PROJECT_NAME}.pc" @ONLY)

# Install library and header
install(TARGETS unarr
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Install pkg-config file
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}/lib${PROJECT_NAME}.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== test/Makefile ===
# GNU Makefile

build ?= debug

OUT := build/$(build)

default: all

# --- Configuration ---

CFLAGS += -Wall -D_FILE_OFFSET_BITS=64
LIBS += -lm

ifeq "$(build)" "debug"
CFLAGS += -pipe -g -DDEBUG
else ifeq "$(build)" "profile"
CFLAGS += -pipe -O3 -DNDEBUG -pg
LDFLAGS += -pg
else ifeq "$(build)" "release"
CFLAGS += -pipe -O3 -DNDEBUG -fomit-frame-pointer
else ifeq "$(build)" "coverage"
CFLAGS += -pipe -g -DDEBUG -pg -fprofile-arcs -ftest-coverage
LIBS += -lgcov
else
$(error unknown build setting: '$(build)')
endif

# --- Commands ---

ifneq "$(verbose)" "yes"
QUIET_AR = @ echo ' ' ' ' AR $@ ;
QUIET_CC = @ echo ' ' ' ' CC $@ ;
QUIET_LINK = @ echo ' ' ' ' LINK $@ ;
endif

CC_CMD = $(QUIET_CC) mkdir -p $(@D) ; $(CC) $(CFLAGS) -o $@ -c $<
AR_CMD = $(QUIET_AR) $(AR) cr $@ $^
LINK_CMD = $(QUIET_LINK) $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

# --- Third party libraries ---

# TODO: build zlib, bzip2 and 7z when available

# --- unarr files ---

UNARR_OUT := $(OUT)/unarr

UNARR_DIRS := .. ../common ../lzmasdk ../rar ../tar ../zip ../_7z
UNARR_SRC := $(wildcard $(UNARR_DIRS:=/*.c))
UNARR_OBJ := $(addprefix $(UNARR_OUT)/, $(addsuffix .o, $(basename $(UNARR_SRC))))

$(UNARR_OUT)/%.o : %.c
	$(CC_CMD)

UNARR_LIB := $(OUT)/libunarr.a

$(UNARR_LIB): $(UNARR_OBJ)
	$(AR_CMD)

UNARR_TEST := $(OUT)/unarr-test

$(UNARR_TEST) : $(UNARR_OUT)/main.o $(UNARR_LIB)
	$(LINK_CMD)

# TODO: add header dependencies

# --- Clean and Default ---

all: $(UNARR_TEST)

clean:
	rm -rf build

.PHONY: all clean

=== debian/changelog ===
unarr (1.0.1-3) unstable; urgency=medium

  * Properly separate dev and library package
  * Add watch file
  * Update copyright info
  * Fix conflict with Debian downstream

 -- Felix Kauselmann <licorn@gmail.com>  Sat, 16 Jul 2022 10:44:10 +0200

unarr (1.0.1-1) UNRELEASED; urgency=low

  * Update to 1.0.1
  * This fixes a problem with libdir in libunarr.pc

 -- Felix Kauselmann <licorn@gmail.com>  Sun, 05 Nov 2017 09:14:29 +0100

unarr (1.0.0-2) UNRELEASED; urgency=low

  * Initial release

 -- Felix Kauselmann <licorn@gmail.com>  Fri, 08 May 2015 22:15:50 +0200

=== debian/control ===
Source: unarr
Priority: optional
Maintainer: Felix Kauselmann <licorn@gmail.com>
Build-Depends: debhelper (>= 9), cmake, zlib1g-dev, libbz2-dev, liblzma-dev
Standards-Version: 4.1.0
Section: libs
Homepage: https://github.com/selmf/unarr

Package: libunarr-dev
Section: libdevel
Architecture: any
Depends: libunarr1 (= ${binary:Version}), ${misc:Depends}
Description: A decompression library for rar, tar, zip and 7zip files. Development version.

Package: libunarr1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libunarr
Breaks: libunarr
Description: A decompression library for rar, tar, zip and 7zip files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@

=== debian/watch ===
version=4
  https://github.com/selmf/unarr/releases .*/v?\d\S+/unarr-?(\d\S+)\.tar\.xz

## unarr 1.1.1

=== debian/changelog ===
unarr (1.1.1-0.1~mx25) mx; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 Nov 2025 10:02:48 -0800

unarr (1.0.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move Alec Leamas from Uploaders to Maintainers.
    OpenCPN is no longer maintained within the GIS team.
  * Add Build-Depends-Package field to symbols file.
  * Bump Standards-Version to 4.6.1, no changes.
  * Remove package name from lintian overrides.
  * Update gbp.conf to use --source-only-changes by default.
  * Drop Name field from upstream metadata.
  * Bump debhelper compat to 12, changes:
    - Drop --parallel option, enabled by default
  * Bump watch file version to 4.
  * Update lintian overrides.
  * Update watch file for GitHub URL changes.
  * Add Rules-Requires-Root to control file.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Dec 2022 22:16:04 +0100

unarr (1.0.1-1) unstable; urgency=medium

  [ Alec Leamas ]
  * Move to use fork at https://github.com/selmf/unarr
  * Handle regular releases at new upstream
  * Drop all patches besides a spelling error.

  [ Bas Couwenberg ]
  * Update watch file to handle common issues.
  * Update upstream metadata for new upstream.
  * Update symbols version to reflect new upstream releases.

 -- Alec Leamas <leamas.alec@gmail.com>  Mon, 01 Oct 2018 01:23:17 -0400

unarr (0~20150801.d1be8c4-1) unstable; urgency=medium

  * Initial release (Closes: #907070)

 -- Alec Leamas <leamas.alec@gmail.com>  Sun, 02 Sep 2018 00:44:03 -0400

=== debian/control ===
Source: unarr
Maintainer: Alec Leamas <leamas.alec@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12), cmake, libbz2-dev, zlib1g-dev
Standards-Version: 4.6.1
Homepage: https://github.com/selmf/unarr
Rules-Requires-Root: no

Package: libunarr-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libunarr1 (= ${binary:Version}), ${misc:Depends}
Description: Decompression library for RAR, TAR, ZIP and 7z archives (devel)
 unarr originated as a port of the RAR extraction features from
 The Unarchiver project required for extracting images from comic
 book archives (.cbr). It was written as an alternative to
 libarchive which didn't have support for parsing filters or solid
 compression at the time.
 .
 This package contains development tools: headers and unversioned libraries.

Package: libunarr1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Decompression library for RAR, TAR, ZIP and 7z archives (runtime)
 unarr originated as a port of the RAR extraction features from
 The Unarchiver project required for extracting images from comic
 book archives (.cbr). It was written as an alternative to
 libarchive which didn't have support for parsing filters or solid
 compression at the time.
 .
 This package holds the runtime library.
